;**********************************************************************
;                                                                     *
;    Filename:	    main.asm                                          *
;    Date:                                                            *
;    File Version:                                                    *
;                                                                     *
;    Author:        el@jap.hu                                         *
;                   http://jap.hu/                                    *
;**********************************************************************
; HISTORY
;
; 000 - 20010223 initial version
;**********************************************************************
;
;    Notes:
;**********************************************************************

	list      p=16F84             ; list directive to define processor
	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC
	;WDT=watchdog, PWRTE=power on timer, XT= crystal osc

#include <p16F84.inc>         ; processor specific variable definitions
#include "pbus.inc"
#include "lcdlib.inc"

freemem UDATA

;***** VARIABLES
lcnt		RES 1
icnt		res 1
w_save		RES 1
s_save		RES 1

vectors		CODE 0

		nop
  		goto    main              ; go to beginning of program
		nop
		nop
		goto int_handler

		CODE 5
messages	movwf PCL
msg_1		dt "Pbus-041 slave", 0

int_handler	movwf w_save
		swapf STATUS, W
		movwf s_save
		incf icnt, F
		call pbus_int_handler

		swapf s_save, W
		movwf STATUS
		swapf w_save
		swapf w_save, W
		retfie

main		clrf PORTA
		clrf PORTB
		movlw 0xe0
		tris PORTA ; PA4=output
		movlw 1
		tris PORTB ; PB0=input

		call pbus_init
		call lcd_init

		movlw msg_1
		call lcd_strout

loop		movlw 0xc0
		call lcd_cmdout

		movf rxe1cnt, W
		call lcd_hexout
		movf rxe2cnt, W
		call lcd_hexout
		movf rxe3cnt, W
		call lcd_hexout

		movf icnt, W
		call lcd_hexout
		movf TMR0, W
		call lcd_hexout
		movf INTCON, W
		call lcd_hexout
		goto loop

pbus_handler	retlw 0xff ; no handler
		end

